/* afg3r.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int afg3r_c(real *a, real *b, real *z__, integer *n, integer *
        m)
{
    /* Initialized data */

    static real zero = 0.f;
    static real one = 1.f;

    /* System generated locals */
    integer a_dim1, a_offset, b_dim1, b_offset, z_dim1, z_offset, i__1, i__2, 
            i__3;
    real r__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    extern /* Subroutine */ int am12r_c(real *, real *, real *, real *, real *,
             real *);
    static integer i__, j, k, l;
    static real r__, s, t;
    static integer k1, l1;
    static logical wantx;
    static real u1, u2, v1, v2;
    static integer lb;
    static real sd;
    static integer nk1, nm1, nm2;
    static real rho;


#define a_ref(a_1,a_2) a[(a_2)*a_dim1 + a_1]
#define b_ref(a_1,a_2) b[(a_2)*b_dim1 + a_1]
#define z___ref(a_1,a_2) z__[(a_2)*z_dim1 + a_1]

    /* Parameter adjustments */
    z_dim1 = *n;
    z_offset = z_dim1 + 1;
    z__ -= z_offset;
    b_dim1 = *n;
    b_offset = b_dim1 + 1;
    b -= b_offset;
    a_dim1 = *n;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    wantx = FALSE_;
    if (*m == 1) {
        goto L3;
    }
    wantx = TRUE_;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        i__2 = *n;
        for (j = 1; j <= i__2; ++j) {
            z___ref(i__, j) = zero;
/* L1: */
        }
        z___ref(i__, i__) = one;
/* L2: */
    }
L3:
    nm1 = *n - 1;
    if (*n <= 1) {
        goto L22;
    }
    i__1 = nm1;
    for (l = 1; l <= i__1; ++l) {
        l1 = l + 1;
        s = zero;
        i__2 = *n;
        for (i__ = l1; i__ <= i__2; ++i__) {
            s += (r__1 = b_ref(i__, l), abs(r__1));
/* L4: */
        }
        if (s == zero) {
            goto L13;
        }
        s += (r__1 = b_ref(l, l), abs(r__1));
        r__ = zero;
        sd = one / s;
        i__2 = *n;
        for (i__ = l; i__ <= i__2; ++i__) {
            b_ref(i__, l) = b_ref(i__, l) * sd;
/* Computing 2nd power */
            r__1 = b_ref(i__, l);
            r__ += r__1 * r__1;
/* L5: */
        }
        r__ = (real)sqrt(r__);
        if (b_ref(l, l) < zero) {
            r__ = -r__;
        }
        b_ref(l, l) = b_ref(l, l) + r__;
        rho = r__ * b_ref(l, l);
        sd = one / rho;
        i__2 = *n;
        for (j = l1; j <= i__2; ++j) {
            t = zero;
            i__3 = *n;
            for (i__ = l; i__ <= i__3; ++i__) {
                t += b_ref(i__, l) * b_ref(i__, j);
/* L6: */
            }
            t = -t * sd;
            i__3 = *n;
            for (i__ = l; i__ <= i__3; ++i__) {
                b_ref(i__, j) = b_ref(i__, j) + t * b_ref(i__, l);
/* L7: */
            }
/* L8: */
        }
        i__2 = *n;
        for (j = 1; j <= i__2; ++j) {
            t = zero;
            i__3 = *n;
            for (i__ = l; i__ <= i__3; ++i__) {
                t += b_ref(i__, l) * a_ref(i__, j);
/* L9: */
            }
            t = -t * sd;
            i__3 = *n;
            for (i__ = l; i__ <= i__3; ++i__) {
                a_ref(i__, j) = a_ref(i__, j) + t * b_ref(i__, l);
/* L10: */
            }
/* L11: */
        }
        b_ref(l, l) = -s * r__;
        i__2 = *n;
        for (i__ = l1; i__ <= i__2; ++i__) {
            b_ref(i__, l) = zero;
/* L12: */
        }
L13:
        ;
    }
    if (*n <= 2) {
        goto L22;
    }
    nm2 = *n - 2;
    i__1 = nm2;
    for (k = 1; k <= i__1; ++k) {
        k1 = k + 1;
        nk1 = *n - k1;
        i__2 = nk1;
        for (lb = 1; lb <= i__2; ++lb) {
            l = *n - lb;
            l1 = l + 1;
            am12r_c(&a_ref(l, k), &a_ref(l1, k), &u1, &u2, &v1, &v2);
            if (u1 != one) {
                goto L16;
            }
            i__3 = *n;
            for (j = k; j <= i__3; ++j) {
                t = a_ref(l, j) + u2 * a_ref(l1, j);
                a_ref(l, j) = a_ref(l, j) + t * v1;
                a_ref(l1, j) = a_ref(l1, j) + t * v2;
/* L14: */
            }
            a_ref(l1, k) = zero;
            i__3 = *n;
            for (j = l; j <= i__3; ++j) {
                t = b_ref(l, j) + u2 * b_ref(l1, j);
                b_ref(l, j) = b_ref(l, j) + t * v1;
                b_ref(l1, j) = b_ref(l1, j) + t * v2;
/* L15: */
            }
L16:
            am12r_c(&b_ref(l1, l1), &b_ref(l1, l), &u1, &u2, &v1, &v2);
            if (u1 != one) {
                goto L20;
            }
            i__3 = l1;
            for (i__ = 1; i__ <= i__3; ++i__) {
                t = b_ref(i__, l1) + u2 * b_ref(i__, l);
                b_ref(i__, l1) = b_ref(i__, l1) + t * v1;
                b_ref(i__, l) = b_ref(i__, l) + t * v2;
/* L17: */
            }
            b_ref(l1, l) = zero;
            i__3 = *n;
            for (i__ = 1; i__ <= i__3; ++i__) {
                t = a_ref(i__, l1) + u2 * a_ref(i__, l);
                a_ref(i__, l1) = a_ref(i__, l1) + t * v1;
                a_ref(i__, l) = a_ref(i__, l) + t * v2;
/* L18: */
            }
            if (! wantx) {
                goto L20;
            }
            i__3 = *n;
            for (i__ = 1; i__ <= i__3; ++i__) {
                t = z___ref(i__, l1) + u2 * z___ref(i__, l);
                z___ref(i__, l1) = z___ref(i__, l1) + t * v1;
                z___ref(i__, l) = z___ref(i__, l) + t * v2;
/* L19: */
            }
L20:
            ;
        }
/* L21: */
    }
L22:
    return 0;
} /* afg3r_c */

#undef z___ref
#undef b_ref
#undef a_ref
