/* agt0r.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__0 = 0;
static integer c__41 = 41;

/* Subroutine */ int agt0r_c(real *a, real *b, real *v, real *alfr,
         real *alfi, real *beta, integer *n, integer *ierr)
{
    /* Initialized data */

    static real zero = 0.f;
    static real one = 1.f;
    static real half = .5f;
    static real sys051 = 1.192093e-7f;

    /* System generated locals */
    integer a_dim1, a_offset, b_dim1, b_offset, v_dim1, v_offset, i__1, i__2;
    real r__1, r__2, r__3, r__4;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    extern /* Subroutine */ int am12c_c(real *, real *, real *, real *, real *,
             real *, real *);
    static real alfm, almi;
    extern /* Subroutine */ int am12r_c(real *, real *, real *, real *, real *,
             real *);
    static real betm, epsa, epsb;
    static logical flip;
    static real almr, tkki;
    static integer iret;
    static real tlki, tkli, tlli, tkkr, tklr, tllr, tlkr;
    extern /* Subroutine */ int aft0r_c(real *, real *, real *, integer *,
            integer *, integer *);
    static real c__, d__, e, f, h__;
    static integer i__, j, k, l, m;
    static real r__, s, t;
    extern /* Subroutine */ int utag10_c(integer *, integer *);
    static real anorm, bnorm;
    static integer l1;
    static real u1, v1, v2, u2, a11, a21, b11, a22, b12, b22, a12, di, ei, an,
             bn, cq;
    static integer mi;
    static real er, dr, cz, ti;
    static integer mr;
    static real sk, sl, xi, yi, zi, tr, xr, yr, zr, a11i, a12i, a22i, bdi, 
            a21i, a11r, a21r, a12r, a22r, bdr, ani, bni, ski, sli, eps, tkk, 
            tlk, tll, sqi, tkl, ssi, skr, slr, sqr, szi, ssr, szr;


#define a_ref(a_1,a_2) a[(a_2)*a_dim1 + a_1]
#define b_ref(a_1,a_2) b[(a_2)*b_dim1 + a_1]
#define v_ref(a_1,a_2) v[(a_2)*v_dim1 + a_1]

    /* Parameter adjustments */
    --beta;
    --alfi;
    --alfr;
    v_dim1 = *n;
    v_offset = v_dim1 + 1;
    v -= v_offset;
    b_dim1 = *n;
    b_offset = b_dim1 + 1;
    b -= b_offset;
    a_dim1 = *n;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    *ierr = 0;
    eps = sys051;
    aft0r_c(&a[a_offset], &b[b_offset], &v[v_offset], n, &c__0, ierr);
    anorm = zero;
    bnorm = zero;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        ani = zero;
        if (i__ != 1) {
            ani = (r__1 = a_ref(i__, i__ - 1), abs(r__1));
        }
        bni = zero;
        i__2 = *n;
        for (j = 1; j <= i__2; ++j) {
            ani += (r__1 = a_ref(i__, j), abs(r__1));
            bni += (r__1 = b_ref(i__, j), abs(r__1));
/* L1: */
        }
        if (ani > anorm) {
            anorm = ani;
        }
        if (bni > bnorm) {
            bnorm = bni;
        }
/* L2: */
    }
    if (anorm == zero) {
        anorm = eps;
    }
    if (bnorm == zero) {
        bnorm = eps;
    }
    epsa = eps * anorm;
    epsb = eps * bnorm;
    m = *n;
L3:
    if (m == 1) {
        goto L4;
    }
    if (a_ref(m, m - 1) != zero) {
        goto L5;
    }
L4:
    alfr[m] = a_ref(m, m);
    if (b_ref(m, m) < zero) {
        alfr[m] = -alfr[m];
    }
    beta[m] = (r__1 = b_ref(m, m), abs(r__1));
    alfi[m] = zero;
    --m;
    goto L16;
L5:
    l = m - 1;
    if ((r__1 = b_ref(l, l), abs(r__1)) > epsb) {
        goto L6;
    }
    b_ref(l, l) = zero;
    am12r_c(&a_ref(l, l), &a_ref(m, l), &u1, &u2, &v1, &v2);
    goto L12;
L6:
    if ((r__1 = b_ref(m, m), abs(r__1)) > epsb) {
        goto L7;
    }
    b_ref(m, m) = zero;
    am12r_c(&a_ref(m, m), &a_ref(m, l), &u1, &u2, &v1, &v2);
    bn = zero;
    goto L8;
L7:
    an = (r__1 = a_ref(l, l), abs(r__1)) + (r__2 = a_ref(l, m), abs(r__2)) +
            (r__3 = a_ref(m, l), abs(r__3)) + (r__4 = a_ref(m, m), abs(r__4));
    bn = (r__1 = b_ref(l, l), abs(r__1)) + (r__2 = b_ref(l, m), abs(r__2)) +
            (r__3 = b_ref(m, m), abs(r__3));
    f = one / an;
    a11 = a_ref(l, l) * f;
    a12 = a_ref(l, m) * f;
    a21 = a_ref(m, l) * f;
    a22 = a_ref(m, m) * f;
    f = one / bn;
    b11 = b_ref(l, l) * f;
    b12 = b_ref(l, m) * f;
    b22 = b_ref(m, m) * f;
    e = a11 / b11;
    c__ = ((a22 - e * b22) / b22 - a21 * b12 / (b11 * b22)) * half;
    d__ = c__ * c__ + a21 * (a12 - e * b12) / (b11 * b22);
    if (d__ < zero) {
        goto L15;
    }
    if (c__ >= zero) {
        e += c__ + (real)sqrt(d__);
    }
    if (c__ < zero) {
        e += c__ - (real)sqrt(d__);
    }
    a11 -= e * b11;
    a12 -= e * b12;
    a22 -= e * b22;
    flip = abs(a11) + abs(a12) >= abs(a21) + abs(a22);
    if (flip) {
        am12r_c(&a12, &a11, &u1, &u2, &v1, &v2);
    }
    if (! flip) {
        am12r_c(&a22, &a21, &u1, &u2, &v1, &v2);
    }
L8:
    if (u1 != one) {
        goto L11;
    }
    i__1 = m;
    for (i__ = 1; i__ <= i__1; ++i__) {
        t = a_ref(i__, m) + u2 * a_ref(i__, l);
        a_ref(i__, m) = a_ref(i__, m) + v1 * t;
        a_ref(i__, l) = a_ref(i__, l) + v2 * t;
        t = b_ref(i__, m) + u2 * b_ref(i__, l);
        b_ref(i__, m) = b_ref(i__, m) + v1 * t;
        b_ref(i__, l) = b_ref(i__, l) + v2 * t;
/* L9: */
    }
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        t = v_ref(i__, m) + u2 * v_ref(i__, l);
        v_ref(i__, m) = v_ref(i__, m) + v1 * t;
        v_ref(i__, l) = v_ref(i__, l) + v2 * t;
/* L10: */
    }
L11:
    if (bn == zero) {
        goto L14;
    }
    flip = an >= abs(e) * bn;
    if (flip) {
        am12r_c(&b_ref(l, l), &b_ref(m, l), &u1, &u2, &v1, &v2);
    }
L12:
    if (u1 != one) {
        goto L14;
    }
    if (! flip) {
        am12r_c(&a_ref(l, l), &a_ref(m, l), &u1, &u2, &v1, &v2);
    }
    i__1 = *n;
    for (j = l; j <= i__1; ++j) {
        t = a_ref(l, j) + u2 * a_ref(m, j);
        a_ref(l, j) = a_ref(l, j) + v1 * t;
        a_ref(m, j) = a_ref(m, j) + v2 * t;
        t = b_ref(l, j) + u2 * b_ref(m, j);
        b_ref(l, j) = b_ref(l, j) + v1 * t;
        b_ref(m, j) = b_ref(m, j) + v2 * t;
/* L13: */
    }
L14:
    a_ref(m, l) = zero;
    b_ref(m, l) = zero;
    alfr[l] = a_ref(l, l);
    alfr[m] = a_ref(m, m);
    if (b_ref(l, l) < zero) {
        alfr[l] = -alfr[l];
    }
    if (b_ref(m, m) < zero) {
        alfr[m] = -alfr[m];
    }
    beta[l] = (r__1 = b_ref(l, l), abs(r__1));
    beta[m] = (r__1 = b_ref(m, m), abs(r__1));
    alfi[m] = zero;
    alfi[l] = zero;
    m += -2;
    goto L16;
L15:
    er = e + c__;
    ei = (real)sqrt(-d__);
    a11r = a11 - er * b11;
    a11i = ei * b11;
    a12r = a12 - er * b12;
    a12i = ei * b12;
    a21r = a21;
    a21i = zero;
    a22r = a22 - er * b22;
    a22i = ei * b22;
    flip = abs(a11r) + abs(a11i) + abs(a12r) + abs(a12i) >= abs(a21r) +
            abs(a22r) + abs(a22i);
    if (flip) {
        r__1 = -a11r;
        r__2 = -a11i;
        am12c_c(&a12r, &a12i, &r__1, &r__2, &cz, &szr, &szi);
    }
    if (! flip) {
        r__1 = -a21r;
        r__2 = -a21i;
        am12c_c(&a22r, &a22i, &r__1, &r__2, &cz, &szr, &szi);
    }
    flip = an >= (abs(er) + abs(ei)) * bn;
    if (flip) {
        r__1 = cz * b11 + szr * b12;
        r__2 = szi * b12;
        r__3 = szr * b22;
        r__4 = szi * b22;
        am12c_c(&r__1, &r__2, &r__3, &r__4, &cq, &sqr, &sqi);
    }
    if (! flip) {
        r__1 = cz * a11 + szr * a12;
        r__2 = szi * a12;
        r__3 = cz * a21 + szr * a22;
        r__4 = szi * a22;
        am12c_c(&r__1, &r__2, &r__3, &r__4, &cq, &sqr, &sqi);
    }
    ssr = sqr * szr + sqi * szi;
    ssi = sqr * szi - sqi * szr;
    tr = cq * cz * a11 + cq * szr * a12 + sqr * cz * a21 + ssr * a22;
    ti = cq * szi * a12 - sqi * cz * a21 + ssi * a22;
    bdr = cq * cz * b11 + cq * szr * b12 + ssr * b22;
    bdi = cq * szi * b12 + ssi * b22;
    r__ = (real)sqrt(bdr * bdr + bdi * bdi);
    beta[l] = bn * r__;
    alfr[l] = an * (tr * bdr + ti * bdi) / r__;
    alfi[l] = an * (tr * bdi - ti * bdr) / r__;
    tr = ssr * a11 - sqr * cz * a12 - cq * szr * a21 + cq * cz * a22;
    ti = -ssi * a11 - sqi * cz * a12 + cq * szi * a21;
    bdr = ssr * b11 - sqr * cz * b12 + cq * cz * b22;
    bdi = -ssi * b11 - sqi * cz * b12;
    r__ = (real)sqrt(bdr * bdr + bdi * bdi);
    beta[m] = bn * r__;
    alfr[m] = an * (tr * bdr + ti * bdi) / r__;
    alfi[m] = an * (tr * bdi - ti * bdr) / r__;
    m += -2;
L16:
    if (m > 0) {
        goto L3;
    }
    m = *n;
L17:
    if (alfi[m] != zero) {
        goto L24;
    }
    alfm = alfr[m];
    betm = beta[m];
    b_ref(m, m) = one;
    l = m - 1;
    if (l == 0) {
        goto L23;
    }
L18:
    l1 = l + 1;
    sl = zero;
    i__1 = m;
    for (j = l1; j <= i__1; ++j) {
        sl += (betm * a_ref(l, j) - alfm * b_ref(l, j)) * b_ref(j, m);
/* L19: */
    }
    if (l == 1) {
        goto L20;
    }
    if (betm * a_ref(l, l - 1) != zero) {
        goto L21;
    }
L20:
    d__ = betm * a_ref(l, l) - alfm * b_ref(l, l);
    if (d__ == zero) {
        d__ = (epsa + epsb) * half;
    }
    b_ref(l, m) = -sl / d__;
    --l;
    goto L23;
L21:
    k = l - 1;
    sk = zero;
    i__1 = m;
    for (j = l1; j <= i__1; ++j) {
        sk += (betm * a_ref(k, j) - alfm * b_ref(k, j)) * b_ref(j, m);
/* L22: */
    }
    tkk = betm * a_ref(k, k) - alfm * b_ref(k, k);
    tkl = betm * a_ref(k, l) - alfm * b_ref(k, l);
    tlk = betm * a_ref(l, k);
    tll = betm * a_ref(l, l) - alfm * b_ref(l, l);
    d__ = tkk * tll - tkl * tlk;
    if (d__ == zero) {
        d__ = (epsa + epsb) * half;
    }
    b_ref(l, m) = (tlk * sk - tkk * sl) / d__;
    flip = abs(tkk) >= abs(tlk);
    if (flip) {
        b_ref(k, m) = -(sk + tkl * b_ref(l, m)) / tkk;
    }
    if (! flip) {
        b_ref(k, m) = -(sl + tll * b_ref(l, m)) / tlk;
    }
    l += -2;
L23:
    if (l > 0) {
        goto L18;
    }
    --m;
    goto L35;
L24:
    almr = alfr[m - 1];
    almi = alfi[m - 1];
    betm = beta[m - 1];
    mr = m - 1;
    mi = m;
    b_ref(m - 1, mr) = almi * b_ref(m, m) / (betm * a_ref(m, m - 1));
    b_ref(m - 1, mi) = (betm * a_ref(m, m) - almr * b_ref(m, m)) / (betm * 
            a_ref(m, m - 1));
    b_ref(m, mr) = zero;
    b_ref(m, mi) = -one;
    l = m - 2;
    if (l == 0) {
        goto L34;
    }
L25:
    l1 = l + 1;
    slr = zero;
    sli = zero;
    i__1 = m;
    for (j = l1; j <= i__1; ++j) {
        tr = betm * a_ref(l, j) - almr * b_ref(l, j);
        ti = -almi * b_ref(l, j);
        slr = slr + tr * b_ref(j, mr) - ti * b_ref(j, mi);
        sli = sli + tr * b_ref(j, mi) + ti * b_ref(j, mr);
/* L26: */
    }
    if (l == 1) {
        goto L27;
    }
    if (betm * a_ref(l, l - 1) != zero) {
        goto L29;
    }
L27:
    dr = betm * a_ref(l, l) - almr * b_ref(l, l);
    di = -almi * b_ref(l, l);
    iret = 1;
    xr = -slr;
    xi = -sli;
    yr = dr;
    yi = di;
    goto L47;
L28:
    b_ref(l, mr) = zr;
    b_ref(l, mi) = zi;
    --l;
    goto L34;
L29:
    k = l - 1;
    skr = zero;
    ski = zero;
    i__1 = m;
    for (j = l1; j <= i__1; ++j) {
        tr = betm * a_ref(k, j) - almr * b_ref(k, j);
        ti = -almi * b_ref(k, j);
        skr = skr + tr * b_ref(j, mr) - ti * b_ref(j, mi);
        ski = ski + tr * b_ref(j, mi) + ti * b_ref(j, mr);
/* L30: */
    }
    tkkr = betm * a_ref(k, k) - almr * b_ref(k, k);
    tkki = -almi * b_ref(k, k);
    tklr = betm * a_ref(k, l) - almr * b_ref(k, l);
    tkli = -almi * b_ref(k, l);
    tlkr = betm * a_ref(l, k);
    tlki = zero;
    tllr = betm * a_ref(l, l) - almr * b_ref(l, l);
    tlli = -almi * b_ref(l, l);
    dr = tkkr * tllr - tkki * tlli - tklr * tlkr;
    di = tkkr * tlli + tkki * tllr - tkli * tlkr;
    if (dr == zero && di == zero) {
        dr = (epsa + epsb) * half;
    }
    iret = 2;
    xr = tlkr * skr - tkkr * slr + tkki * sli;
    xi = tlkr * ski - tkkr * sli - tkki * slr;
    yr = dr;
    yi = di;
    goto L47;
L31:
    b_ref(l, mr) = zr;
    b_ref(l, mi) = zi;
    flip = abs(tkkr) + abs(tkki) >= abs(tlkr);
    iret = 3;
    if (flip) {
        goto L32;
    }
    xr = -slr - tllr * b_ref(l, mr) + tlli * b_ref(l, mi);
    xi = -sli - tllr * b_ref(l, mi) - tlli * b_ref(l, mr);
    yr = tlkr;
    yi = tlki;
    goto L47;
L32:
    xr = -skr - tklr * b_ref(l, mr) + tkli * b_ref(l, mi);
    xi = -ski - tklr * b_ref(l, mi) - tkli * b_ref(l, mr);
    yr = tkkr;
    yi = tkki;
    goto L47;
L33:
    b_ref(k, mr) = zr;
    b_ref(k, mi) = zi;
    l += -2;
L34:
    if (l > 0) {
        goto L25;
    }
    m += -2;
L35:
    if (m > 0) {
        goto L17;
    }
    m = *n;
L36:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        s = zero;
        i__2 = m;
        for (j = 1; j <= i__2; ++j) {
            s += v_ref(i__, j) * b_ref(j, m);
/* L37: */
        }
        v_ref(i__, m) = s;
/* L38: */
    }
    --m;
    if (m > 0) {
        goto L36;
    }
    m = *n;
L39:
    s = zero;
    if (alfi[m] != zero) {
        goto L42;
    }
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        r__ = (r__1 = v_ref(i__, m), abs(r__1));
        if (r__ < s) {
            goto L40;
        }
        s = r__;
        d__ = v_ref(i__, m);
L40:
        ;
    }
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        v_ref(i__, m) = v_ref(i__, m) / d__;
/* L41: */
    }
    --m;
    goto L46;
L42:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        r__ = (r__1 = v_ref(i__, m - 1), abs(r__1)) + (r__2 = v_ref(i__, m), 
                abs(r__2));
/* Computing 2nd power */
        r__1 = v_ref(i__, m - 1) / r__;
/* Computing 2nd power */
        r__2 = v_ref(i__, m) / r__;
        r__ *= (real)sqrt(r__1 * r__1 + r__2 * r__2);
        if (r__ < s) {
            goto L43;
        }
        s = r__;
        dr = v_ref(i__, m - 1);
        di = v_ref(i__, m);
L43:
        ;
    }
    iret = 4;
    i__ = 0;
L44:
    ++i__;
    xr = v_ref(i__, m - 1);
    xi = v_ref(i__, m);
    yr = dr;
    yi = di;
    goto L47;
L45:
    v_ref(i__, m - 1) = zr;
    v_ref(i__, m) = zi;
    if (i__ < *n) {
        goto L44;
    }
    m += -2;
L46:
    if (m > 0) {
        goto L39;
    }
    goto L50;
L47:
    if (abs(yr) < abs(yi)) {
        goto L48;
    }
    h__ = yi / yr;
    f = yr + h__ * yi;
    zr = (xr + h__ * xi) / f;
    zi = (xi - h__ * xr) / f;
    goto L49;
L48:
    h__ = yr / yi;
    f = yi + h__ * yr;
    zr = (h__ * xr + xi) / f;
    zi = (h__ * xi - xr) / f;
L49:
    switch (iret) {
        case 1:  goto L28;
        case 2:  goto L31;
        case 3:  goto L33;
        case 4:  goto L45;
    }
L50:
    if (*ierr != 0) {
        utag10_c(ierr, &c__41);
    }
    return 0;
} /* agt0r_c */

#undef v_ref
#undef b_ref
#undef a_ref
